function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

const { defaults } = require('lodash');
const GitHubApi = require('github');
const { promisify } = require('bluebird');

const contentFromFilename = require('./content-from-filename');
const updateFileWithContent = require('./update-file-with-content');

module.exports = (() => {
  var _ref = _asyncToGenerator(function* (config) {
    const {
      branch = 'master',
      token,
      transform,
      force
    } = config;

    let github = config.github;

    if (!github) {
      github = new GitHubApi();
      github.authenticate({ type: 'oauth', token });
    }

    const content = yield contentFromFilename(github, config);
    const newContent = transform(content.content);

    var transformedConfig = {};
    if (typeof newContent === 'string') transformedConfig.content = newContent;else transformedConfig = newContent;

    const newBranch = transformedConfig.newBranch || config.newBranch;
    if (newBranch) {
      const reference = yield promisify(github.gitdata.getReference)(defaults({
        ref: `heads/${ branch }`
      }, config));

      yield promisify(github.gitdata[force ? 'updateReference' : 'createReference'])(defaults({
        sha: reference.object.sha,
        ref: (force ? '' : 'refs/') + `heads/${ newBranch }`,
        force
      }, config));
    }

    return yield updateFileWithContent(github, defaults({ sha: content.commitSha, branch: newBranch || branch }, transformedConfig, config));
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
})();